<template>
  <div class="full-width row items-center no-wrap">
    <div class="col-5 row no-wrap">
      <span class="text-capitalize ellipsis">{{ formattedDayOfWeek }}</span>
    </div>
    <div
      class="col-2 row justify-center"
    >
      <img
        v-if="icon"
        :src="icon"
        width="20"
      >
    </div>
    <div class="col-1 row justify-center items-center">
      <div class="text-blue">
        {{ formattedTemperatureMin }}
      </div>
    </div>
    <div class="col-1 row justify-center items-center">
      <div class="text-red">
        {{ formattedTemperatureMax }}
      </div>
    </div>
    <div
      class="col-4 column items-center no-wrap justify-center text-info"
      :class="{'text-small': !isDesktopPlatform}"
      v-if="hasPrecipitation || hasWind"
    >
      <WeatherPrecipitationText
        v-if="hasPrecipitation"
        :probability="precipitationProbability"
        :intensity="precipitationIntensity"
      />
      <WeatherWindText
        v-if="hasWind"
        :wind-speed="windSpeed"
        :wind-bearing="windBearing"
        :wind-gust="windGust"
      />
    </div>
  </div>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import WeatherPrecipitationText from 'src/pages/home/feed/weather/WeatherPrecipitationText'
import WeatherWindText from 'src/pages/home/feed/weather/WeatherWindText'

export default {
  name: 'WeatherDetailsDay',
  mixins: [PlatformMixin],
  components: {
    WeatherPrecipitationText,
    WeatherWindText
  },
  props: {
    day: {
      type: Date,
      required: true
    },
    icon: {
      type: String,
      default: null
    },
    temperatureMax: {
      type: Number,
      required: true
    },
    temperatureMin: {
      type: Number,
      required: true
    },
    precipitationProbability: {
      type: Number,
      default: null
    },
    precipitationIntensity: {
      type: Number,
      default: null
    },
    windSpeed: {
      type: Number,
      default: null
    },
    windBearing: {
      type: Number,
      default: null
    },
    windGust: {
      type: Number,
      default: null
    }
  },
  computed: {
    hasPrecipitation () {
      return (
        (this.precipitationProbability !== null && this.precipitationProbability > 0) ||
        (this.precipitationIntensity !== null && this.precipitationIntensity > 0))
    },
    hasWind () {
      return this.windSpeed !== null && Math.round(this.windSpeed * 3.6) > 0
    },
    formattedDayOfWeek () {
      const day = new Date(this.day)
      const dayOfWeek = new Intl.DateTimeFormat(
        this.$store.state.fastplatform.preferredLanguage,
        { weekday: 'long' }).format(day)
      const dayOfMonth = new Intl.DateTimeFormat(
        this.$store.state.fastplatform.preferredLanguage,
        { day: 'numeric' }).format(day)

      return `${dayOfWeek} ${dayOfMonth}`
    },
    formattedTemperatureMax () {
      if (this.temperatureMax === null) {
        return ''
      }
      return Math.round(this.temperatureMax) + '°'
    },
    formattedTemperatureMin () {
      if (this.temperatureMin === null) {
        return ''
      }
      return Math.round(this.temperatureMin) + '°'
    }
  }
}
</script>
